
const dotenv = require('dotenv');
dotenv.config();

import { Api, JsonRpc, RpcError } from 'eosjs';
import { JsSignatureProvider } from 'eosjs/dist/eosjs-jssig';
const signatureProvider = new JsSignatureProvider([dappstakeinfo.ownerkey, "5KGeTxdh6FZwvfqVWPEBiBP3sFKEm1ud3pKjKmb4cpZ8Z4RNxoM"]);
const dspEndpt = contract.NODEOS_ENDPOINT;

const rpc = new JsonRpc(dspEndpt, { fetch });
import { TextEncoder, TextDecoder } from 'text-encoding';
import { InternalServerErrorException } from '@nestjs/common';
import { getOrderedKeys } from 'src/ipfs-dapp-service/utils/ipfs-service/get-ordered-keys';
import { deserializeVactionPayload } from './serialize.action';
const api = new Api({
    rpc,
    signatureProvider,
    textDecoder: new TextDecoder(),
    textEncoder: new TextEncoder(),
});
const ecc = require("eosjs-ecc");
const axios = require('axios').default;
import * as retry from 'async-retry';




// export async function getsinglebyname(contractacc, scope, table, key) {
//     try {
//         let res;
//         let resobj = {};
//         await retry(
//             async (bail, Numberbail) => {
//                 const dataString1 =
//                     '{"contract":"' +
//                     contractacc +
//                     '","scope":"' +
//                     scope +
//                     '","table":"' +
//                     table +
//                     '","key":"' +
//                     key +
//                     '"}';

//                 const options = {
//                     url: contract.get_table_row,
//                     method: 'POST',
//                     body: dataString1,
//                 };
//                 resobj = {};
//                 if (Numberbail < 3) {
//                     res = await rp(options);
//                     resobj = JSON.parse(res);
//                 }
//             },
//             {
//                 retries: 2,
//             }
//         );
//         console.log("from outer", resobj);
//         return resobj;
//     } catch (err) {
//         const res = {};
//         return res;
//     }
// }

export async function serializedtrx(contractac, method, actor, data) {
    try {
        const result = await api.transact(
            {
                actions: [
                    {
                        account: contractac,
                        name: method,
                        authorization: [
                            {
                                actor,
                                permission: 'active',
                            },
                        ],
                        data,
                    },
                ],
            },
            {
                blocksBehind: 3,
                expireSeconds: 120,
                broadcast: false,
                sign: false
            },
        );
        return result;
    } catch (err) {
        throw new Error(err);
    }


}


export async function signtrx(contractac, method, actor, data) {
    try {
        let serializedtrxresp;
        await retry(
            async (bail, num) => {
                if (num < 4) {
                    console.log('Num', num)
                    serializedtrxresp = await serializedtrx(contractac, method, actor, data);
                }
            },
            {
                retries: 3,
            },
        );
        let signkey = '';
        if (serializedtrxresp) {
            const signBuf = Buffer.concat([
                Buffer.from(contract.chainId, "hex"),
                Buffer.from(serializedtrxresp.serializedTransaction),
                Buffer.from(new Uint8Array(32))
            ]);
            // if (actor == contract.contract) {
            //     signkey = contract.contract_key
            // } else if (actor == dappstakeinfo.owner) {

            // }
            signkey = "5KGeTxdh6FZwvfqVWPEBiBP3sFKEm1ud3pKjKmb4cpZ8Z4RNxoM" //dappstakeinfo.ownerkey
            let signature_owner = ecc.sign(signBuf, signkey);
            console.log(signature_owner)
            let resultcontrac_new = {};
            resultcontrac_new.signatures = [];
            resultcontrac_new.signatures.push(signature_owner);
            resultcontrac_new.serializedTransaction = serializedtrxresp.serializedTransaction;
            console.log('here')
            let temp = await pushTransaction(contractac, method, actor, data,
                [], resultcontrac_new)
            return temp;
        }
        else {
            throw new Error('Error in serialize action');
        }

    } catch (err) {
        throw new Error(err.message);
    }
}

export async function gettrxbyid(trxid) {

    try {
        const dspEndpt = contract.gettrx;
        const rpc = new JsonRpc(dspEndpt, { fetch });
        const api = new Api({
            rpc,
            signatureProvider,
            textDecoder: new TextDecoder(),
            textEncoder: new TextEncoder(),
        });
        let resp = await rpc.history_get_transaction(trxid)
        //console.log('--', resp)

        return resp;

    } catch (err) {
        console.log('gettrx error')
        const error = JSON.stringify(err);
        if (!(error.includes("trx not found") || error.includes("tx_not_found") || error.includes("not found"))) {
            throw new Error(err.message);
        } else {
            let resp = {}
            resp.error = error
            return resp
        }
    }
}

export async function getCorrectTransactionId(transactionIds) {

    const requests = transactionIds.map(v => gettrxbyid(v))
    const responses = await axios.all(requests)
    console.log('--responses', responses)
    let index = -1

    for (let i = 0; i < responses.length; i++) {
        if (responses[i].error) {
            continue
        } else {
            index = i
            break
        }
    }

    if (index >= 0) {
        return transactionIds[index]
    }

    return ''
}

export async function pushTransaction(
    contractac, method, actor, data,
    txIds,
    trxpayload
) {
    console.log('here--,', txIds)
    if (txIds.length) {
        const txId = await getCorrectTransactionId(txIds)
        console.log('in push trx--', txId)
        if (txId.length > 0) {
            return true
        }
    }
    try {
        const response = await api.pushSignedTransaction(trxpayload);
        console.log('--resp', response.transaction_id)
        const txId = response.transaction_id
        txIds.push(txId)
        console.log('length of array--', txIds.length)
        if (txIds.length > 25) {
            return signtrx(contractac, method, actor, data)
        } else {
            return pushTransaction(contractac, method, actor, data,
                txIds,
                trxpayload)
        }
    } catch (e) {
        console.log('--here', e)
        const error = JSON.stringify(e)
        if (
            error.includes('Call updateacckey to add keys') ||
            error.includes('No unstake entry found for this symbol') ||
            error.includes('No refund pending for this symbol') || error.includes('duplicate transaction')) {

            if (txIds.length > 0) {
                console.log('trx array--', txIds);
                if (error.includes('duplicate transaction')) {
                    await wait(6000);
                    let trxcheck = await gettrxbyid(txIds[0]);
                    console.log('trx check--', trxcheck)
                    if (trxcheck.error) {
                        return pushTransaction(contractac, method, actor, data,
                            txIds,
                            trxpayload)
                    }
                }
                console.log('--successful')
                return true
            } else {
                await telegramreport(error, method);
                throw new Error(e.message)
            }

        } else if (error.includes('expired transaction')) {
            return signtrx(contractac, method, actor, data)
        }
        else {
            throw new Error(e.message)
            //throw new Error(e.message)
        }
    }
}

async function wait(ms) {
    var start = new Date().getTime();
    var end = start;
    while (end < start + ms) {
        end = new Date().getTime();
    }
}
